package fr.example.queryloader;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

import fr.example.queryloader.util.SQLQuery;

/**
 * <p>Programme principal.</p>
* </p>
 * 
 * @author jaubin
 *
 */
public class QueryLoader {
 
	public static void main(String[] args) throws Throwable {
		BlockingQueue<SQLQuery> queryQueue = new LinkedBlockingQueue<SQLQuery>(65536);
		List<QueryLoaderRunnable> queryLoaderRunnables = new ArrayList<QueryLoaderRunnable>();
		// On peut customiser le nombre de threads a lancer, la j'ai mis 4....
		for (int i = 0, len = 4; i < len; i++) {
			QueryLoaderRunnable queryLoaderRunnable = new QueryLoaderRunnable(queryQueue);
			new Thread(queryLoaderRunnable).start();
			queryLoaderRunnables.add(queryLoaderRunnable);
		}
	
		System.out.println("Processing queries.");
		
		for (int i = 0; i < Integer.MAX_VALUE; i++) {		
			queryQueue.put(new SQLQuery());
		}		
		
		System.out.println("Stopping runnables.");
		for (QueryLoaderRunnable qlr: queryLoaderRunnables) {
			qlr.setTerminated();
		}
	}

}
